# GTA5 源码编译所需要的补丁

> ### 如果你之前已经应用过这些补丁，请重新解压整个源代码，以确保错误可以重现并报告。

- 解压 {rage,game} 到 X:\gta5\src\ 并覆盖
- 解压 "ROOT_DLL" 内的所有文件到 titleupdate
- 记得禁用 Visual Studio 项目的 “将所有警告视为错误” 选项
- 可选：将 "OPTIONAL_DLL" 内的 socialclub.dll 复制到 `C:\Program Files\Rockstar Games\Social Club Debug` 目录下

## 以类似零售版的方式启动游戏并使任务流程正常工作：
- 在 gameconfig.xml (`update.rpf/common/data/`) 中将 MISSION 的 SizeOfStack 设置为 53000
- 将 _编译好的_ scripts.rpf 复制到 `update2.rpf/levels/gta5/scripts` (!! 需要重新加密编辑过的 RPF !!)
- 使用 `-DoReleaseStartup` 参数运行可执行文件

## 如果你编辑了任何 RPF 文件：

- 请使用 [Archivefix.exe](https://staticfile-cn.zerodream.net/files/gta5-source/ArchiveFix.zip) 重新加密任何编辑过的 RPF 文件。

### 通用注释：
以下是推荐使用的启动参数，将以下内容复制，然后在 `X:\gta5\build\dev_ng` 目录下创建一个文本文件，重命名为 `run.bat`，然后将内容粘贴到 `run.bat` 文件中，然后双击运行 `run.bat` 文件即可。

```
@echo off
game_win64_debug.exe -rootdir "X:\gta5\build\dev_ng/" -audiopack "X:\gta5\build\dev_ng/x64/audio/audio.rpf" -commonpack "X:\gta5\build\dev_ng/common.rpf" -assetsdir "X:\gta5\build\dev_ng" -noSocialClub -nonetlogs -audio -output -nodebugpack -usepackfiles -platformpack "x64.rpf" -kbgame -update "." -override_script script -sc_DisableForbiddenVehicleRemoval -nokeyboardhook -width 1280 -height 720 -windowed
```

以下是启动参数的详细说明：

- 启动参数：`-noSocialClub -nokeyboardhook -nonetlogs`
- `-noSocialClub` - 修复激活问题
- `-nokeyboardhook` - 防止游戏卡住按键
- `-nonetlogs` - 修复 message.log 引起的崩溃

### 附加启动参数：
- `-output` - 添加调试控制台输出
- `-kbgame` - 默认使用游戏键盘而不是调试键盘
- `-rag` - 使用 Rockstar 的游戏调试工具
- `-ragUseOwnWindow` - 游戏将会在自己的窗口中运行，而不是附加到调试器

### 其他非必须的启动参数：
- -useFinalShaders - 不需要，调试着色器已经提供，而最终着色器不适用于调试版本
- -audiopack - 不需要，游戏已经默认使用 audio_rel.rpf
- -langfilesuffix - 不需要，游戏已经默认使用 american_rel
- -commonpack, -nodebugpack, -usepackfiles, -platformpack, -assetsdir - 不需要，代码更改已经使游戏默认加载打包文件
- -nonetwork - 不推荐，因为它会在你退出暂停菜单时崩溃游戏
- -disablecacheloader - 不需要，代码更改已经使游戏加载正确的缓存文件

### 注意：
- 你需要 v2699 游戏版本更新和 update2.rpf，编译好的调试着色器，以及编译好的 script.rpf
- 着色器从游戏文件夹中的 common/shaders 目录中加载，不需要重新打包 common.rpf
- 着色器质量必须高于 normal，否则它会从 win32_40_lq 加载，而我们还没有编译好它
- 按 LCtrl+Tab 切换键盘模式，从调试切换到游戏，否则需要使用控制器

## 可选修复
- "OPTIONAL_FIXES" 文件夹包含了一个临时的代码，用于修复 RGSC 和移除 Epic API，如果你需要它们，请从中复制到 `X:\gta5\src` 目录下